ActiveAdmin.register_page "Dashboard" do

  menu :priority => 1, :label => proc{ I18n.t("active_admin.dashboard") }

  content :title => proc{ I18n.t("active_admin.dashboard") } do
    columns do
      column :span => 6 do
        panel 'Users Statistics' do
          table do
            tr do
              th '', width: 100
              th '', width: 100
              
              th 'Registered'
              th 'Active Users'
              th 'Active Users who created Collections'
              
              th 'Total Items Added'
              th 'Total Collections Created'
            end
            
            records = User.results_per_active_months
            
            tr do
              td records.first[:start_date].to_s(:short)
              td records.last[:end_date].to_s(:short)
              
              td records.collect {|e| e[:info][:registered] }.sum
              td records.collect {|e| e[:info][:active_users] }.sum
              td records.collect {|e| e[:info][:active_users_with_collections] }.sum
              
              td records.collect {|e| e[:info][:total_items_added] }.sum
              td records.collect {|e| e[:info][:total_collections_created] }.sum
            end
            
            records.reverse.each do |record|
              tr do
                td record[:start_date].to_s(:short)
                td record[:end_date].to_s(:short)
                
                td record[:info][:registered]
                td record[:info][:active_users]
                td record[:info][:active_users_with_collections]
                
                td record[:info][:total_items_added]
                td record[:info][:total_collections_created]
              end
            end
          end
        end
      end
      
      # column do
        # panel 'Active Users' do
          # dl do
            # dt 'Daily'
            # dd User.active_in_past_day.count
# 
            # dt 'Weekly'
            # dd User.active_in_past_week.count
# 
            # dt 'Monthly'
            # dd User.active_in_past_month.count
          # end
        # end
      # end

      column do
        panel 'Collections' do
          dl do
            dt 'Total Count'
            dd Message.count
          end
        end
      end

      column do
        panel 'Items Posted' do
          dl do
            dt 'Total Count'
            dd Item.count
          end
        end
      end
    end
  end # content
end
