ActiveAdmin.register Item do
  menu :label => "Items", :parent => "Items Management"
  
  filter :message_id, label: 'Collection ID', as: :numeric 
  
  config.batch_actions = false
  
  actions :all, :except => [:new, :destroy]
  
  index do
    selectable_column
    
    column :id
    
    column 'Collection ID', :message_id
    column 'Collection Name' do |record|
      record.message.subject
    end
    column :title
    
    column :brand
    column :price
    
    column :clicks_count
    
    default_actions
  end
  
  show do |record|
    attributes_table do
      row :id
      row 'Collection ID' do
        record.message_id
      end
      row 'Collection', :message do
        record.message.subject
      end
      row :title
      row :brand
      row :price
      row :url
      row :deleted
      row :description
      row :hide_price
      row :likes_count
      row :comments_count
      row :clicks_count
      row :image do
        image_tag(record.image.url(:size300))
      end
    end
  end
  
  form do |f|
    f.inputs do
      f.input :title
      f.input :brand
      f.input :price
      f.input :description
      f.input :image
      f.input :url
    end

    f.actions
  end
end