ActiveAdmin.register Scraper do
  show do
    default_main_content

    render partial: 'test_url'
  end

  form :partial => 'form'
  
  controller do
    def index
      index! do |format|
        format.js do
          if params[:test_url].present?
            @scraped_items = if params[:scraper].present?
              @scraper_message = if Scraper.scraper_matches_domain(params[:test_url], params[:scraper][:domain])
                "Scraper matched"
              else
                "WARNING: Scraper did NOT match domain (#{params[:test_url]}, #{params[:scraper][:domain]})"
              end
              params[:scraper].each { |label, selector| params[:scraper][label] = Array.wrap(selector) }
              # TODO: make it more prominent if we fail to match the current scraper
              params[:scraper][:skip_diffbot] = true
              Scraper.scrap_with_selectors(params[:test_url], params[:scraper])
            else
              @scraper_message = Scraper.get_scraper_for_url( URI.encode(params[:test_url]) )
              Scraper.scrap(params[:test_url])
            end

            @scraped_items ||= {}
            @test_result_table = render_to_string(partial: 'test_result')

            render :test_result_show
          end
        end
      end
    end
  end
end
