ActiveAdmin.register UsersStatistic do
  # scope :all, default: true
  # scope :invitation_not_accepted

  index do
    selectable_column
    
    column :id
    
    column 'Start Time' do |record|
      record.start_time.to_date.to_s(:short)
    end
    column 'End Time' do |record|
      record.end_time.to_date.to_s(:short)
    end
    
    column 'Asking for Invitation' do |record|
      record[:info][:asked_for_invitation]  
    end
    column 'Invited' do |record|
      record[:info][:invited]  
    end
    column 'Invited and Registered' do |record|
      record[:info][:invited_and_registered]  
    end
    column 'Direcly Registered' do |record|
      record[:info][:directly_registered]  
    end
    column 'Registered' do |record|
      record[:info][:registered]  
    end
    column 'Active Users' do |record|
      record[:info][:active_users]  
    end
    column 'Active Users who created Collections' do |record|
      record[:info][:active_users_with_collections]  
    end
    
    default_actions
  end
end