Tisket.require('Tisket.Notifications', function(){
  var that = {};
  
  var hideAutomatically = null;
  
  var init = function(){
    $('.js-notification .js-closeTrigger').click(function(){
      var trigger = $(this);
      var notification = trigger.parents('.js-notification');
      
      notification.hide();
    });
  };
  that.init = init;
  
  var showSuccessMessage = function(message, timeout){
    var notifications = $('.js-notification');
    var notification = notifications.filter('.js-success');
    
    showNotification(notifications, notification, message, timeout);
  };
  that.showSuccessMessage = showSuccessMessage;
  
  var showErrorMessage = function(message, timeout){
    var notifications = $('.js-notification');
    var notification = notifications.filter('.js-error');
    
    showNotification(notifications, notification, message, timeout);
  };
  that.showErrorMessage = showErrorMessage;
  
  var showWarningMessage = function(message, timeout){
    var notifications = $('.js-notification');
    var notification = notifications.filter('.js-warning');
    
    showNotification(notifications, notification, message, timeout);
  };
  that.showWarningMessage = showWarningMessage;
  
  var showInfoMessage = function(message, timeout){
    var notifications = $('.js-notification');
    var notification = notifications.filter('.js-info');
    
    showNotification(notifications, notification, message, timeout);
  };
  that.showInfoMessage = showInfoMessage;
  
  var showNotification = function(notifications, notification, message, timeout){
    notifications.hide();
    
    notification.find('.js-message').html( message ).show();
    notification.show();
    Tisket.Layout.adjustFooterPosition();
    
    if(timeout){
      hideAutomatically = true;
      
      setTimeout(function(){
        if( hideAutomatically ){
          hideAutomatically = false;
          hide();
        }
      }, timeout);
    }
    else
      hideAutomatically = false;
  };
  
  var hide = function(){
    var notifications = $('.js-notification');
    notifications.hide();
    Tisket.Layout.adjustFooterPosition();
  };
  that.hide = hide;
  
  return that;
}());