Tisket.require('Tisket.Overlays.CollectionUpdateOverlay', function(){
  var that = {};
  
  var url = null;
  var onSuccess = null;
  var onError = null;
  
  var shownContainer = null;
  
  var open = function(options){
    extractOptions(options);
    
    $.ajax({
      url: url,
      type: 'get',
      dataType: 'html',
      success: function(response){
        var overlay = $(
          '<div id="updateCollection" class="modal hide fade updateCollection" tabindex="-1" data-replace="true" data-color="white"></div>'
        );
        overlay.html( response );
        
        overlay.on('shown', function(){
          init(overlay);
        });
        
        overlay.modal({
          keyboard: false
        });
      },
      error: function(){
        alert('Something went wrong while loading overlay');
      }
    });
  };
  that.open = open;
  
  var extractOptions = function(options){
    url = options.url;
    onSuccess = options.onSuccess;
    onError = options.onError;
    
    if( options.shownContainer )
      shownContainer = options.shownContainer;
    else
      shownContainer = 'info'; 
  };
  
  var init = function(overlay){
    var recipientsField = overlay.find(".js-receipientsField");
    var userIdsField = overlay.find('.js-userIdsField');
    var form = recipientsField.parents('form');
    var personalizationContainer = overlay.find('.js-personalization');
    var infoContainer = overlay.find('.js-info');
    
    overlay.find('.js-subjectField').focus();
    
    overlay.find('input:radio').iCheck({
      checkboxClass: 'icheckbox_square-grey',
      radioClass: 'iradio_square-grey',
    }).on('ifChecked', function(){
      var field = $(this);
      
      if( field.hasClass('js-private') ){
        userIdsField.attr('disabled', true);
        overlay.find('.js-invitations').show();
      }
      else{
        userIdsField.attr('disabled', false);
        overlay.find('.js-invitations').hide();
      }
    });
    
    overlay.find('input:radio:checked').change();
    
    //-Info Section-----
      infoContainer.find('.js-deleteImageTrigger').click(function(){
        infoContainer.find('.js-removeImage').val('1');
        
        infoContainer.find('.js-new').show();
        infoContainer.find('.js-edit').hide();
        infoContainer.find('.js-imageContainer').removeClass('uploadedImageWrapper').addClass(
          'uploadImageWrapper'
        );
      });
      
      var imageWidth = null;
      
      if( window.File && window.FileReader && window.FileList && window.Blob ){        
        infoContainer.find('input[type=file]').change(function(event){
          infoContainer.find('.js-removeImage').val('0');
          
          files = event.target.files;
          f = files[0];      
    
          // Only process image files.
          if (!f.type.match('image.*')) {
            return;
          }
    
          var reader = new FileReader();
    
          // Closure to capture the file information.
          reader.onload = (function(theFile) {
            return function(e) {
              imageWidth = (e.total / (1024 * 1024)); 
              
              infoContainer.find('.js-image').attr('src', e.target.result);
            };
          })(f);
    
          // Read in the image file as a data URL.
          reader.readAsDataURL(f);
          
          infoContainer.find('.js-new').hide();
          infoContainer.find('.js-edit').show();
          infoContainer.find('.js-deleteImageTrigger').hide();
          infoContainer.find('.js-imageContainer').removeClass('uploadImageWrapper').addClass(
            'uploadedImageWrapper'
          );
        });
      }
    //-----
    
    //-Personalize Section-----      
      personalizationContainer.find('.js-updateTrigger').click(function(){
        if( shownContainer == 'info' ){
          personalizationContainer.hide();
          infoContainer.show();
        }
        else{
          overlay.find('.js-trigger').click();
        }
      });
    //------
    
    Tisket.Layout.initRecipientsField( recipientsField );
    
    overlay.find('.js-trigger').click(function(){
      if(imageWidth != null && imageWidth > 3){
        alert("Image size is too large. Please try a smaller file.");
        return;
      }
      
      overlay.find('.js-loadingMask').removeClass('hidden');
      
      // Adjust Form Data with Image Data as well for AJAX request
      var data = form.serializeArray();
      var formData = new FormData();
      for (var i in data) {
        formData.append(data[i].name, data[i].value);
      }
      var imageField = form.find('input[type=file]');
      if( imageField[0].files[0] ){
        formData.append(imageField.attr("name"), imageField[0].files[0]);
      }
      
      $.ajax({
        url: (form.attr('action') + '.js'),
        type: form.attr('method'),
        data: formData,
        processData: false,
        contentType: false,
        dataType: 'json',
        success: function(response){
          if( onSuccess )
            onSuccess(response);
        },
        error: function(jqXHR){
          if( onError )
            onError(jqXHR, overlay);
        }
      });
    });
    
    if( shownContainer == 'info' )
      infoContainer.show();
    else
      personalizationContainer.show();
  };
  that.init = init;
  
  return that;
}());