class ActivitiesController < ApplicationController
  before_filter :authenticate_user!
  before_filter :authorize_user!
  
  def like
    # @activity is prepared from "authorize_user!" filter
    
    @activity_like = @activity.likes.find_or_initialize_by_user_id( current_user.id )
    
    @activity_like.save!
    
    render_response
  end
  
  def unlike
    # @activity is prepared from "authorize_user!" filter
    
    @activity_like = @activity.likes.find_by_user_id( current_user.id )
    
    @activity_like.destroy if @activity_like
    
    render_response
  end
  
  def likes
    @activity_likes = @activity.likes.includes(:user)
    
    respond_to do |format|
      format.js do
        render :json => {
          :names => @activity_likes.collect {|al| al.user.name }
        }, :status => 200
      end
    end
  end
  
  #-------#
  protected
  #-------#
  
  def authorize_user!
    @activity = Activity.find( params[:id] )
    
    @message = @activity.message
    
    return true if @message.public?
    
    @users = @message.total_users
    return true if @users.collect(&:id).include?(current_user.id)
    
    respond_to do |format|
      format.html { redirect_to root_path }
      format.js { render :json => {}, :status => 403 }
    end
  end
  
  def render_response
    respond_to do |format|
      format.js do
        render :json => {
          :activities_html => render_to_string({
            :partial => 'messages/activities', :formats => 'html', :locals => {:activities => [@activity.reload]}
          })
        }, :status => 200
      end
    end
  end
end