class ApplicationController < ActionController::Base
  protect_from_forgery
  before_filter :authenticate_user!

  rescue_from Exception, :with => :rescue_global_exceptions
  
  #-Exceptions Handling-----
    def rescue_global_exceptions(exception)
      if (params[:format].blank? || params[:format] == 'html')
        unless Rails.application.config.consider_all_requests_local
          rescue_action_in_public_without_airbrake(exception)
        else
          raise( exception )
        end
      else
        rescue_action_in_public_without_airbrake(exception)
      end
    end
  
    def rescue_action_in_public_without_airbrake(exception)
      Airbrake.notify_or_ignore(exception, :rack_env => env)
      
      if exception.class == ActiveRecord::RecordNotFound
        respond_to do |format|
          format.html do
            if params[:controller] == 'errors'
              redirect_to '/404.html'
            else
              redirect_to error_404_errors_path
            end
          end
          
          format.js do
            render json: {error_message: 'Resource not found'}, status: 404
          end
        end
      else
        respond_to do |format|
          format.html do
            if params[:controller] == 'errors'
              redirect_to '/500.html'
            else
              redirect_to error_500_errors_path
            end
          end
          
          format.js do
            render json: {error_message: 'Something went wrong while performing your action!'}, status: 500
          end
        end 
      end
    end
  #-----
  
  #-------#
  protected
  #-------#
  
  def authenticate_inviter! ; end
end