class ExploreController < ApplicationController
  def show
    @collections = []
    
    relation = Message.active.public_ones.has_image.has_items.includes(:owner)
    
    per_page = 9
    @page = (params[:page].presence || 1).to_i
    
    @collections = []
    if @page == 1
      @collections += relation.show_in_explore_page.limit(per_page).all
    end
    if @collections.length < per_page
      @collections += relation.recent.where("impressions_count > 50").page(
        @page
      ).per(per_page - @collections.length).all
    end
    
    respond_to do |format|
      format.html
      format.js  { render partial: 'explore/products', locals: {collections: @collections}, status: 200 }
    end
  end
end