class HomeController < ApplicationController
	skip_before_filter :authenticate_user!
	before_filter :redirect_if_logged_in, only: :show
  
  def show
    @featured_collections = Message.active.public_ones.x_days_old(7).has_items.order('impressions_count DESC').limit(6)
    
    respond_to do |format|
      format.html
    end
  end
  
  def welcome
  	redirect_to(new_user_invitation_path) unless user_signed_in?
  end

  def info
    respond_to do |format|
      format.html
    end
  end
  
  def terms; end
  def privacy
    respond_to do |format|
      format.html { render 'terms' }
    end
  end
  
  #-------#
  protected
  #-------#
  
  def redirect_if_logged_in
    return unless user_signed_in?
    
    respond_to do |format|
      format.html { redirect_to my_profile_path }
    end
  end
end