class Items::CommentsController < ApplicationController
  before_filter :authorize_user!
  
  def index
    # @item is prepared from "authorize_user!" filter
    
    @comments = @item.comments.visible.includes(:user).order('created_at desc')
    
    respond_to do |format|
      format.js do
        render :json => {
          :activities_html => render_to_string({
            :partial => 'messages/activities', :formats => 'html', :locals => {:activities => @comments}
          })
        }, :status => 200
      end
    end
  end
  
  #-------#
  protected
  #-------#
  
  def authorize_user!
    @item = Item.find(params[:item_id])
    
    @message = @item.message
    raise ActiveRecord::RecordNotFound.new unless @message.active? 
    
    return true if @message.public?
    
    @users = @message.total_users
    return true if @users.collect(&:id).include?(current_user.id)
    
    respond_to do |format|
      format.js do
        render :json => {}, :status => 403
      end
    end
  end
end