class Items::ImageController < ApplicationController
  before_filter :authorize_user!
  
  def create
    # @item is prepared from "authorize_user!" filter
    
    @item.image_url = params[:image_url]
    @item.save!
    
    respond_to do |format|
      format.json do
        render :json => {
          :image_url => @item.image_url(:size306)
        }, :status => 200
      end
    end
  end
  
  #-------#
  protected
  #-------#
  
  def authorize_user!
    @item = Item.find(params[:item_id])
    
    return true if current_user.can_edit?(@item)
    
    raise ActiveRecord::RecordNotFound.new
  end
end