class Items::ImagesController < ApplicationController
  before_filter :authorize_user!
  
  def index
    # @item is prepared from "authorize_user!" filter
    
    scraping_response = Scraper.scrap(@item.url)
    
    # Use this for testing to avoid waiting for response
    #["https://s7.jcrew.com/is/image/jcrew/03520_WE4120?$pdp_fs418$", "https://s7.jcrew.com/is/image/jcrew/58206_RD6234_m?$pdp_fs418$"]
    
    respond_to do |format|
      format.json do
        render :json => {
          :images_urls => scraping_response[:images_urls]
        }, :status => 200
      end
    end
  end
  
  #-------#
  protected
  #-------#
  
  def authorize_user!
    @item = Item.find(params[:item_id])
    
    return true if current_user.can_edit?(@item)
    
    raise ActiveRecord::RecordNotFound.new
  end
end