class Items::SaveController < ApplicationController
  before_filter :authorize_user!
  
  def create
    # @item is loaded from "authorize_user!" filter
    
    if !params[:collection_name].blank?
      @collection = current_user.owned_messages.build(subject: params[:collection_name])
      @collection.public = false if @collection.new_record?
    else
      @collection = current_user.navigation_collections.find(params[:collection_id])
    end
    
    begin
      @collection.transaction do
        @collection.save! if @collection.new_record?
        @item.copy_to_collection!(@collection.id, current_user)
      end
      
      respond_to do |format|
        format.js { render nothing: true, status: 200 }
      end
    rescue Exception => e
      Airbrake.notify_or_ignore(e)
      
      respond_to do |format|
        format.js { render nothing: true, status: 500 }
      end
    end
  end
  
  #-------#
  protected
  #-------#
  
  def authorize_user!
    @item = Item.find(params[:item_id])
    
    return if @item.message.public?
    
    respond_to do |format|
      format.js { render nothing: true, status: 403 }
    end
  end
end