class Messages::PersonalizationController < ApplicationController
  def show
    @collection = current_user.owned_messages.find( params[:message_id] ) 
    
    respond_to do |format|
      format.js { render :layout => false }
    end
  end
  
  def create
    @collection = current_user.owned_messages.find( params[:message_id] ) 
    @collection.attributes = params[:message]
    @collection.image_uploaded = true if @collection.image.file?
    
    begin
      @collection.save!
      
      respond_to do |format|
        format.html { redirect_to message_path(@collection) }
      end
    rescue Exception => e
      Airbrake.notify_or_ignore(e)
      
      respond_to do |format|
        format.html do
          flash[:error] = 'Something went wrong while updating collection image!'
          redirect_to message_path(@collection)
        end
      end
    end
  end
end