class ProfilesController < ApplicationController
  skip_before_filter :authenticate_user!
  
  def show
    if params[:id]
      @user = User.find(params[:id])
      @collections = @user.owned_messages.public_ones.active.has_items.has_image.order('last_item_created_at DESC')
    else
      if current_user.nil?
        authenticate_user!
        return false
      end
      
      @user = current_user
      @collections = @user.total_messages(true).active.order('last_item_created_at DESC')
    end
    
    respond_to do |format|
      format.html
    end
  end
end