class Users::RegistrationsController < Devise::RegistrationsController
  def new
    session["user_return_to"] = params[:return_to] unless params[:return_to].blank? 
    
    resource = build_resource({})
    respond_with resource
  end
  
  def create
    build_resource

    if resource.save
      if resource.active_for_authentication?
        if params[:collection_id]
          collection = Message.find( params[:collection_id] )
          resource.invited_by_id = collection.owner_id
          if params[:source] == 'widget'
            resource.invitation_medium = 'carousel'
          end
          resource.save
        end
        
        set_flash_message :notice, :signed_up if is_navigational_format?
        sign_up(resource_name, resource)
        respond_with resource, :location => after_sign_up_path_for(resource)
      else
        set_flash_message :notice, :"signed_up_but_#{resource.inactive_message}" if is_navigational_format?
        expire_session_data_after_sign_in!
        respond_with resource, :location => after_inactive_sign_up_path_for(resource)
      end
    else
      clean_up_passwords resource
      respond_with resource
    end
  end
  
  #-------#
  protected
  #-------#

  def after_sign_up_path_for(resource_or_scope)
    stored_location = stored_location_for(resource_or_scope)
    unless stored_location.blank?
      uri = URI.parse(stored_location)
      new_query_ar = URI.decode_www_form(uri.query.to_s) << ["new_user", "1"]
      uri.query = URI.encode_www_form(new_query_ar)
      stored_location = uri.to_s
    end

    stored_location || root_path(:new_user => 1)
  end
end