class Users::SessionsController < Devise::SessionsController
  protect_from_forgery :except => [:create]
  
  respond_to :extchr
  
  def create
    self.resource = warden.authenticate!(auth_options)
    set_flash_message(:notice, :signed_in) if is_navigational_format?
    sign_in(resource_name, resource)
    
    respond_with(resource, :location => after_sign_in_path_for(resource)) do |format|
      format.extchr do
        render :nothing => true, :status => 200
      end
    end
  end
end