class UsersController < ApplicationController
  def edit
    @user = current_user
    
    respond_to do |format|
      format.html do
        render 'edit'
      end
    end
  end

  def update
    @user = current_user
    @user.attributes = params[:user]
    
    if @user.save
      respond_to do |format|
        format.html do
          flash[:success] = 'Profile Updated Successfully'
          redirect_to edit_user_path(@user.id)
        end
      end
    else
      respond_to do |format|
        format.html do
          render 'edit'
        end
      end
    end
  end

  def update_avatar
    @user = current_user
    if params[:user] && params[:user][:avatar]
      @user.avatar = params[:user][:avatar]
      @user.save
    end
    render action: 'edit'    
  end

  def update_notification_settings
    @user = current_user
    @user.attributes = params[:user]
    
    if @user.save
      respond_to do |format|
        format.html do
          flash[:success] = 'Profile Updated Successfully'
          redirect_to edit_user_path(@user.id)
        end
      end
    else
      respond_to do |format|
        format.html do
          render 'edit'
        end
      end
    end
  end
end