module AssetsHelper
  # This helper yeilds contents to 2 places that should be available
  # in the application layout. One for including javascript files,
  # the other is for including initialization codes. The layout should have
  # something as follows:
  # <%= yield :javascripts %>
  # <script type="text/javascript">
  #   $(function({
  #     <%= yield :javascripts_ready %>
  #   }));
  # </script>
  # Example usage in a certain page:
  # <% javascripts 'file1', 'file2' do %>
  #  alert('welcome here!');
  # <% end %>
  def javascripts(*args, &block)
    content_for(:javascripts) {javascript_include_tag(*args)}
    
    javascripts_ready(&block) if block_given?
  end
  
  def javascripts_ready(&block)
    content_for(:javascripts_ready, &block) if block_given?
  end
  
  def javascripts_load(&block)
    content_for(:javascripts_load, &block) if block_given?
  end
  
  def stylesheets(*args, &block)
    content_for(:stylesheets) {stylesheet_link_tag(*args)}
  end
end