module FormsHelper
  def error_classes ; "js-error notMatch" ; end
  
  def form_field_error(errors, options = {})
    force_addition = (options[:force_addition] || false)
    
    errors = Array.wrap(errors).uniq
    return nil if (errors.length == 0 && force_addition == false)
      
    content_tag(:div, content_tag(:span, errors.join(' & '), :class => error_classes), :class => "err_field")
  end
  
  def form_errors_for(object)
    errors = object.errors[:base]
    if (object.errors.keys - [:base]).length > 0  
      errors << "Some fields below need your attention"
    end
    
    form_errors( errors )
  end
  
  def form_errors(errors)
    html = []
    
    if errors.count > 0
      html << '<div class="globalError">'
      
      html << errors.join("<br />")
      
      html << '</div>'      
    end
    
    raw( html.join("\r\n") )
  end
end