module MessagesHelper
  def number_of_likes(message_id, item_id)
    Activity.where(message_id: message_id, item_id: item_id, kind: Activity::LIKE).count
  end
  
  def brand_name_placeholder ; 'Brand Name' ; end
  def product_name_placeholder ; 'Product Name' ; end
  def price_placeholder ; '' ; end
  def product_description_placeholder ; 'Product Description' ; end
  
  def navigation_collections
    if current_user
      @navigation_collections ||= current_user.navigation_collections.all
    else
      @navigation_collections ||= []
    end
    
    @navigation_collections
  end
  
  def collection_image_url(collection)
    if collection.image.file?
      collection.image.url(:size400)
    else
      collection.items_urls.first.sub('original', 'size400')
    end
  end
end