module UsersHelper
	def user_initials(user)
    if user.last_name.present?
		  "#{user.first_name} #{user.last_name.chr}"
    else
      if user.first_name.present?
        user.first_name
      else
        user.email
      end
    end
	end
	
	def user_image(user, size, options = {})
    if user.avatar.file?
      image_tag(user.avatar.try(:url, (options[:style] || "size#{ size }")), options)
    else
      if options[:ignore_if_empty] && user.initials.empty?
        nil
      else
        raw("<div class=\"noavatar avatar_#{ size }\">#{ (user.initials.presence || '?') }</div>")
      end
    end
  end
end
