class Background::ItemImageGrabber
  if configatron.async.enabled && configatron.async.engine == :sucker_punch
    include SuckerPunch::Job
  end
  
  def self.perform(item_id, image_url)
    if configatron.async.enabled
      if configatron.async.engine == :sucker_punch
        self.new.async.perform(item_id, image_url)
      elsif configatron.async.engine == :delayed_job
        self.new.delay.do_perform(item_id, image_url)
      end
    else
      self.new.do_perform(item_id, image_url)
    end
  end
  
  def perform(item_id, image_url)
    self.do_perform(item_id, image_url)
  end
  
  def do_perform(item_id, image_url)
    item = Item.find_by_id(item_id)
      
    if item
      unless image_url.blank?
        begin
          item.image_url = image_url
        rescue Exception => e
          Airbrake.notify_or_ignore(e)
        end
      end
      
      item.processed = true
      
      item.save!
    end
  end
end