require_dependency 'constants'

class FailedUrl < ActiveRecord::Base
  #-Constants-----
    FAILURE_REASONS = Constants.new({
      crawl_failed: {id: 1, name: 'Crawling Failed'},
      invalid_url: {id: 2, name: 'Invalid Url'}      
    })
  #-----
  
  #-Attributes-----
    attr_accessible :url, :user_id, :failure_reason_id
  #-----
  
  #-Associations-----
    belongs_to :user
    
    def failure_reason
      FAILURE_REASONS.find_by_id(self.failure_reason_id)
    end
  #-----
  
  #-Scopes-----
    scope :failed, where(failure_reason_id: FAILURE_REASONS[:crawl_failed].id)
    scope :invalid_url, where(failure_reason_id: FAILURE_REASONS[:invalid_url].id)
  #-----
end