class Friendship < ActiveRecord::Base
  belongs_to :user
  belongs_to :friend, class_name: :User

  after_create :make_searchable
  after_destroy :make_unsearchable
  
  #-------#
  protected
  #-------#

  def make_searchable
    user.search_users.create(name: friend.name, email: friend.email,
    	                       term: "#{friend.name.downcase} #{friend.email.downcase}")

    friend.search_users.create(name: user.name, email: user.email,
    	                         term: "#{user.name.downcase} #{user.email.downcase}")
  end

  def make_unsearchable
    user.search_users.where(email: friend.email).delete_all
    friend.search_users.where(email: user.email).delete_all
  end

end
