class Impression < ActiveRecord::Base
  #-Associations-----
    belongs_to :user
    belongs_to :collection, class_name: 'Message'
  #-----
  
  #-Callbacks-----
    after_save do |impression|
      if impression.impressions_changed?
        Message.increment_counter(:impressions_count, impression.collection_id)
      end
    end
  #-----
  
  #-Dirty Objects-----
    def impressions_changed?
      self.site_impressions_changed? || self.widget_impressions_changed?
    end
  #-----
end