Airbrake.configure do |config|
  config.api_key = 'a700af99d924b053294fdca827692a87'
  
  entries = config.ignore.clone
  entries.each {|e| config.ignore.delete(e) }
end

# This code prints exception in log if it won't be reported on Airbrake
# since this environment is not public one
module Airbrake
  class << self
    private
  
    def send_notice(notice)
      if configuration.public?
        if configuration.async?
          configuration.async.call(notice)
          nil # make sure we never set env["airbrake.error_id"] for async notices
        else
          sender.send_to_airbrake(notice)
        end
      else
        ::Rails.logger.debug ">>>>>>>>>>Class: #{ notice.error_class }"
        ::Rails.logger.debug ">>>>>>>>>>Message: #{ notice.error_message }"
        ::Rails.logger.debug ">>>>>>>>>>Parameters: #{ notice.parameters }"
        notice.backtrace.lines.each do |l|
          ::Rails.logger.debug l
        end
        ::Rails.logger.debug ">>>>>>>>>>>>>>>>>>>>>>>"  
      end
    end
  end
end