if configatron.paperclip.storage_medium == 'filesystem'
  PAPERCLIP_OPTIONS = {
    :storage => :filesystem,
    :url => "http://#{ configatron.site_domain }/system/:class/:id/:attachment/:style/:filename",
    :path => "#{ Rails.root }/public/system/:class/:id/:attachment/:style/:filename"
  }
elsif configatron.paperclip.storage_medium == 'dropbox'
  Bundler.require(:paperclip_dropbox)
  
  PAPERCLIP_OPTIONS = {
    :storage => :dropbox,
    :dropbox_credentials => configatron.paperclip.dropbox_credentials,
    :path => "/:class/:id/:attachment/:style/:filename"
  }
elsif configatron.paperclip.storage_medium == 's3'
  Bundler.require(:paperclip_s3)

  PAPERCLIP_OPTIONS = {
    :storage => :s3,
    :s3_credentials => configatron.paperclip.s3_credentials,
    :bucket => configatron.paperclip.s3_bucket,
    :path => "/:class/:id/:attachment/:style/:filename",
    :url => ":s3_domain_url"
  }
end
