var tiskItem = 'chrome-extension://' + settings.extensionId() + '/html/tisk_item.html'; 

var myIframe = 'tisket_iframe';
var myDiv = 'tisket_container';

var containerDiv = $('<div>', {
  name: myDiv,
  id: myDiv,
});

var tiskDiv = null;
var currentImage = null;

var createContainerIframe = function(){
  var image = currentImage;
  
  // prepare the title param
  if( image ){
    if(image.parent().is('a') && image.parent().attr('title')){
      var title = image.parent().attr('title')
    }else if(image.attr('alt')) {
      var title = image.attr('alt');
    }else{
      var title = 'New Item';
    }
  }
  else{
    var title = 'New Item';
  }

  // prepare the url param
  var url = window.location.href;
  if( image ){
    var imgLink = image.parents('a');
    if(imgLink.length > 0 && imgLink.prop('href')){
      // Make sure that the value in the enclosing link is not empty
      // Also if the link was a JS link and not a real link then exclude as well
      if( imgLink.prop('href').length > 0 && imgLink.prop('href').toLowerCase().indexOf('javascript:') == -1 )
        url = imgLink.prop('href');
    }
  }
  
  var iframeSrc = tiskItem + '?';
  if( image )
    iframeSrc += ('image_url=' + escape(image.prop('src')) + '&');
  iframeSrc += ('title=' + escape(title) + '&url=' + escape(url));
  
  return $('<iframe />', {
    name: myIframe,
    id: myIframe,
    class: 'overlayContainer',
    src: iframeSrc
  });
}

var openIframe = function(){
  containerDiv.appendTo('body');
  containerIframe = createContainerIframe();
  containerIframe.appendTo('body');
};

// close iframe listener
addEventListener('message', function(ev) {
  if (ev.data === 'closeIframe') {
    containerIframe.remove();
    containerDiv.remove();
  }
});

// close overlay when Esc is clicked
$(document).keyup(function(e) {
  if (e.keyCode == 27) {
    containerIframe.remove();
    containerDiv.remove();
  }
});

var addTisketContainer = function(){
  tiskDiv = $('<div class="tisket js-tisket" style="display:none;"></div>');
  
  tiskDiv.click(function(e){
    e.preventDefault();
    
    containerDiv.click(function(){
      containerIframe.remove();
      containerDiv.remove();
    });
    
    openIframe();
  });
  
  tiskDiv.hover(function(){
    tiskDiv.show();
  }, function(){
    tiskDiv.hide();
  });
  
  $('body').append( tiskDiv );
};

var initImage = function(image){
  image.hover(function(){
    showTisketContainerForImage( image );
  }, function(){
    tiskDiv.hide();
  });
};

var showTisketContainerForImage = function(image){
  currentImage = image;
  
  var imageWidth = image.width();
  var imageHeight = image.height();

  // make sure that the image is larger than 150 x 150 and not hidden
  if(imageWidth >= 150 && imageHeight >= 150 && image.css('display') != 'none' && image.css('visibility') != 'hidden'){
    var imagePosition = image.offset();

    tiskDiv.css('top', imagePosition.top + imageHeight - 49);
    tiskDiv.css('left', imagePosition.left + imageWidth - 49);

    tiskDiv.show();
  }
  else{
  }
};

var onImageLoad = function(image){
  if( image.complete ){
      initImage( $(image) );
    }
    else{
      $(image).load(function(){
        initImage( $(image) );
      });
    }
};

chrome.runtime.sendMessage({cmd: "domainSupported", domain: window.location.host}, function(response){
  if(response.supported){
    addTisketContainer();
    
    $('img').livequery(function(){
      onImageLoad(this);
    });
  }
});

chrome.runtime.onMessage.addListener(function(request, sender, sendResponse){
  if (request.cmd === "openOverlay"){
    currentImage = null;
    openIframe();
  }
});

$('body').attr('data-tisket-extension-installed', '1');