$(document).ready(function() {

  var tiskItem = 'chrome-extension://' + settings.extensionId() + '/html/tisk_item.html'; 

  var myIframe = 'tisket_iframe';
  var myDiv = 'tisket_container';

  var containerDiv = $('<div>', {
    name: myDiv,
    id: myDiv,
  });
  
  $('img').each(function(){
    var image = $(this);
    
    var imageWidth = image.width();
    var imageHeight = image.height();

    if(imageWidth >= 150 && imageHeight >= 150){
      var imagePosition = image.position();
      var tiskDiv = $('<div class="tisket" style="display:none;"></div>');

      tiskDiv.css('top', imagePosition.top + imageHeight - 49);
      tiskDiv.css('left', imagePosition.left + imageWidth - 49);

      addListerToTiskDiv(tiskDiv, $(this));

      image.hover(function(){
        tiskDiv.show();
      }, function(){
        tiskDiv.hide();
      });
      tiskDiv.hover(function(){
        tiskDiv.show();
      }, function(){
        tiskDiv.hide();
      });

      image.after(tiskDiv);
    }
  });

  function createContainerIframe(image){
    // prepare the title param
    if(image.parent().is('a') && image.parent().attr('title')){
      var title = image.parent().attr('title')
    }else {
      var title = image.attr('alt');
    }

    // prepare the url param
    if(image.parent().is('a') && image.parent().prop('href')){
      var url = image.parent().prop('href')
    }else {
      var url = window.location;
    }
    
    return $('<iframe />', {
      name: myIframe,
      id: myIframe,
      class: 'overlayContainer',
      src: tiskItem + '?image_url=' + image.prop('src') + '&title=' + title + '&url=' + url
    });
  }

  function addListerToTiskDiv(div, image) {
    div.click(function(e) {
      e.preventDefault();
      containerDiv.appendTo('body');
      addListerToDiv();
      containerIframe = createContainerIframe(image);
      containerIframe.appendTo('body');
    });
  }

  function addListerToDiv() {
    containerDiv.click(function() {
      containerIframe.remove();
      containerDiv.remove();
    });
  }

  // close iframe listener
  addEventListener('message', function(ev) {
    if (ev.data === 'closeIframe') {
        containerIframe.remove();
        containerDiv.remove();
      }
  });

  // close overlay when Esc is clicked
  $(document).keyup(function(e) {
    if (e.keyCode == 27) {
      containerIframe.remove();
      containerDiv.remove();
    }
  });

});