$(document).ready(function() {
  var errors = {
    problemOccurred: "We had some trouble pulling the product information. Email us at contact@tisket.com with the link you are trying to add, and we'll be happy to help out!",
    notLoggedIn: "Please login on tisket to grap your collections"
  };

  var collectionsDDL = $('#collection_id');
  //make an ajax request to the following URL
  $.ajax({
    url: settings.hostName() + 'collections/open.extchr',
    success: function(result){
      result = jQuery.parseJSON(result);
      for (var i = 0; i < result.length; i++) {
        option = $('<option value="'+result[i].id+'">'+result[i].subject+'</option>');
        option.appendTo(collectionsDDL);
      };
    },
    error: function(xhr, textStatus) {
      closeOverlay();
      
      if(xhr.status == 401){
        alert(errors.notLoggedIn);
      }
      else{
        alert(errors.problemOccurred);
      }
    }
  });

  // populate some values from url
  $('#item_title').html(getParameterByName('title'));
  $('#item_image').attr('src', getParameterByName('image_url'));
  $('#item_url').val(getParameterByName('url'));

  // get a param by name from page url (window.location) in javascript
  function getParameterByName(name) {
    name = name.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
    var regex = new RegExp("[\\?&]" + name + "=([^&#]*)"),
        results = regex.exec(location.search);
    return results == null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
  }

  var addItemToCollection = function(collectionSource){
    // if the collectionSource is ddl it will use the val of collection_id element
    // else it will use the string sored in the variable collectionSource itself
    collectionId = (collectionSource == 'ddl') ? collectionsDDL.val() : collectionSource ;
    // make sure that the collectionId is selected
    if (collectionId == ''){
      alert('Please select a collection');
    }else{
      // grap the data
      data = {
        item : {
          title: $('#item_title').text(),
          image_url: $('#item_image').prop('src'),
          url: $('#item_url').val()
        }
      }

      // make a post request to tisket rails application
      $.ajax({
        type: "POST",
        url: settings.hostName() + 'collections/' + collectionId + '/add_item.extchr',
        data: data,
        beforeSend: function(){
          $('#add_item_btn').prop("disabled",true);
        },
        success: function(result){
          alert(result);
          parent.postMessage('closeIframe', '*');
        },
        complete: function(xhr, textStatus) {
          $('#add_item_btn').prop("disabled",false);
          if(xhr.status != 200){
            alert(errors.problemOccurred);
            parent.postMessage('closeIframe', '*');
          }
        }
      });
    }
  };

  // reate the collection then call the function addItemToCollection
  var createCollectionThenAddItem = function(){
    if ($('#collection_subject').val() == ''){
      alert('please write a collection name');
    }else{
      // grap the data
      data = {
        message: {
          subject: $('#collection_subject').val()
        }
      }

      // make a post request to tisket rails application
      $.ajax({
        type: "POST",
        url: settings.hostName() + 'collections.extchr',
        data: data,
        beforeSend: function(){
          $('#add_item_btn').prop("disabled",true);
        },
        success: function(result){
          addItemToCollection(result);
        },
        complete: function(xhr, textStatus) {
          $('#add_item_btn').prop("disabled",false);
          if(xhr.status != 200){
            alert("We had some trouble pulling the product information. Email us at contact@tisket.com with the link you are trying to add, and we'll be happy to help out!");
            parent.postMessage('closeIframe', '*');
          }
        }
      });
    }
  };

  // the default click action on the add button
  $('#add_item_btn').click(function(){
    addItemToCollection('ddl');
  });

  // switch focus and click handler when radio button changes
  $(':radio').click(function(){
    if($(this).attr('id') == 'radio_collection_id'){
      //change the focused element
      $('#collection_id').focus();
      // change click handler on the save button
      $('#add_item_btn').unbind('click');
      $('#add_item_btn').click(function(){
        addItemToCollection('ddl');
      });
    }else if ($(this).attr('id') == 'radio_collection_subject'){
      //change the focused element
      $('#collection_subject').focus();
      // change click handler on the save button
      $('#add_item_btn').unbind('click');
      $('#add_item_btn').click(createCollectionThenAddItem);
    }
  });

  var closeOverlay = function(){
    parent.postMessage('closeIframe', '*');
  };

  // close overlay when Esc is clicked
  $(document).keyup(function(e) {
    if (e.keyCode == 27) {
      closeOverlay();
    }
  });

  $('.js-newCollectionSubject').focus(function(){
    $('.js-newCollectionOption').attr('checked', true);
    $('.js-existingCollectionOption').attr('checked', false);
  });
});